package com.survey7.flashcards;

/*
Copyright 2012 Sanjay Rao, Seattle WA USA

This file is part of Flash Cards GPL.

Flash Cards GPL is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

Flash Cards GPL is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Flash Cards GPL.  If not, see <http://www.gnu.org/licenses/>.
*/

import android.app.Activity;
import android.content.Intent;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.DialogInterface;
import android.content.res.Configuration;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.widget.EditText;
import android.widget.Button;
import android.util.Log;
import android.content.SharedPreferences;
import android.os.Environment;
import java.io.FilenameFilter;
import java.io.File;
import java.util.ArrayList;
import android.widget.LinearLayout;
import android.view.ViewGroup;
import java.util.Comparator;
import java.util.Collections;
import org.json.JSONObject;
import org.json.JSONArray;
import org.json.JSONException;
import android.util.TypedValue;
import android.graphics.Color;
import android.view.Gravity;
import java.util.zip.ZipFile;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import java.io.InputStream;
import java.io.FileOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.BufferedInputStream;
import android.os.Handler;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Map;
import java.util.List;
import java.util.Set;

public class Download extends Activity {
	private static final String DBG="FlashCards";
	private Globals globals;
	private String code,password,filename;
	private Handler onehandler;
	private Runnable delaydownload;

	@Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
	}
	@Override
	public void onCreate(Bundle savedInstanceState) {
		globals=(Globals)((Globalcontainer)getApplicationContext()).globals;
		globals.init(this);
		super.onCreate(savedInstanceState);
		setContentView(R.layout.download);
		onehandler=new Handler();
		delaydownload=new Runnable() {
			public void run() {
				downloadfromserver();
			}
		};

		((Button)findViewById(R.id.button_httpdownload)).setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) {
					code=((EditText)findViewById(R.id.code_httpdownload)).getText().toString();
					password=((EditText)findViewById(R.id.password_httpdownload)).getText().toString();
					disableui();
					onehandler.postDelayed(delaydownload,100);
				}
			});
	}
	private void disableui() {
		findViewById(R.id.layout_downloadui).setVisibility(View.GONE);
		splash("Downloading...");
	}
	private void splash(String str) {
		((TextView)findViewById(R.id.status_download)).setText(str);
	}
	private boolean mediaready() {
		String state=Environment.getExternalStorageState();
		if (Environment.MEDIA_MOUNTED.equals(state)) return true;
		return false;
	}
	private boolean writefile(String fn, byte[] data) {
		if (!mediaready()) { splash("Media not mounted"); return true; }
		File dir;
		dir=Environment.getExternalStorageDirectory(); // how could this be atomic?
		if (dir==null) {
			splash("!getExternalStorageDirectory");
			return true;
		}
		String path=dir.getAbsolutePath()+"/Android/data/"+getString(R.string.package_name)+"/downloads";
		File f=new File(path);
		if (!f.exists()) f.mkdirs(); // ignore error
		f=new File(path+"/"+fn);
		if (f==null) {
			splash("Error creating "+path+fn);
			return true;
		}
		FileOutputStream fos=null;
		try { fos=new FileOutputStream(f); } catch(java.io.FileNotFoundException e) {}
		if (fos==null) {
			splash("Error streaming "+path+fn);
			return true;
		}
		try {
			fos.write(data);
			fos.close();
			return false;
		} catch(java.io.IOException e) {
			splash("Error writing to file");
			return true;
		}
	}
/*
import org.apache.http.client.HttpClient;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
	private byte[] httprequest(String url) {
		try {
			HttpClient client;
			HttpResponse resp;
			StatusLine status;
			client=new DefaultHttpClient();
			resp=client.execute(new HttpGet(url));
			status=resp.getStatusLine();
			if (status.getStatusCode()==200) {
				ByteArrayOutputStream ret=new ByteArrayOutputStream();
				resp.getEntity().writeTo(ret);
				return ret.toByteArray();
			}
		} catch(java.io.IOException e) { }
		return null;
	}
*/
	private byte[] httprequest(String url) {
		byte[] resp=null;
		HttpURLConnection HUC=null;
		try {
			HUC=(HttpURLConnection)(new URL(url)).openConnection();
			InputStream is=HUC.getInputStream();
			resp=datautils.slurpstream2(is);
			if (resp[0]=='{') {
				String message;
				String jsonstring=new String(resp);
				try {
					JSONObject json=new JSONObject(jsonstring);
					message=json.getString("message");
				} catch(org.json.JSONException e) {
					message="Unknown error. Is this an old version?\n"+jsonstring;
				}
				splash("Error downloading cards: "+message);
				resp=null;
			} else {
				Map<String,List<String>> headers;
				List<String> values;
				headers=HUC.getHeaderFields();
				if (headers!=null) {
					values=headers.get("Content-disposition");
					if (values!=null) {
						String str=values.get(0);
						if (str.substring(0,22).equals("attachment; filename=\"")) {
							filename=str.substring(22,str.length()-1);
						}
					}
				}
			}
		} 
		catch (java.net.MalformedURLException e) {}
		catch (java.io.IOException e) {}
		finally { HUC.disconnect(); }
		return resp;
	}
	private boolean invalidfilename() {
		int i,n;
		n=filename.length();
		for (i=0;i<n;i++) {
			switch (filename.charAt(i)) {
				case '/':
				case '\t':
				case '\\':
					return true;
			}
		}
		return false;
	}
	private void downloadfromserver() {
		byte[] resp=null;
		splash("Connecting to survey7.com");
		code=code.trim();
		password=password.trim();
		filename=code+"_flashcards.zip";
		resp=httprequest("http://www.survey7.com/flashcards/fetch?CODE="+code+"&PASSWORD="+password);
		if (resp==null) return;
		if (invalidfilename()) {
			splash("Invalid filename. Old version? "+filename);
			return;
		}
		splash("Saving file to device");
		writefile(filename,resp);
		splash("Success");
		globals.needscan=true;

		Intent intent=new Intent();
		intent.setClass(this,Library.class);
		startActivity(intent);
		finish();
		System.gc();
	}
}
