package com.survey7.flashcards;

/*
Copyright 2012 Sanjay Rao, Seattle WA USA

This file is part of Flash Cards GPL.

Flash Cards GPL is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

Flash Cards GPL is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Flash Cards GPL.  If not, see <http://www.gnu.org/licenses/>.
*/

import java.util.Collections;
import java.util.Arrays;
import android.os.Handler;
import android.content.res.Configuration;
import android.app.Activity;
import android.os.Bundle;
import android.text.Html;
import android.view.GestureDetector;
import android.view.GestureDetector.SimpleOnGestureListener;
import android.view.MotionEvent;
import android.view.Window;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Button;
import android.view.ViewGroup;
import android.util.Log;
import java.lang.StringBuilder;
import android.text.SpannableString;
import android.text.style.UnderlineSpan;
import android.graphics.Color;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.view.Gravity;
import android.util.TypedValue;
import android.text.method.LinkMovementMethod;
import android.graphics.drawable.BitmapDrawable;
import android.widget.ImageView;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import android.net.Uri;
import android.content.Intent;
import android.graphics.Bitmap;


public class back implements cardside {
	private static final String DBG="FlashCards";
	private Globals globals;
	float dpratio;
	private int pixels;
	FlashCards FC;
	GestureDetector GD;
	public void setactivity(FlashCards act) {
		FC=act;
		globals=(Globals)((Globalcontainer)FC.getApplicationContext()).globals;
		dpratio=globals.dpratio;
		int w,h;
		w=FC.getResources().getDisplayMetrics().widthPixels;
		h=FC.getResources().getDisplayMetrics().heightPixels;
		if (h<w) w=h;
		pixels=(int)((8*w)/10);
	}
	public void unsetup() {
//		((ScrollView)FC.findViewById(R.id.backscroll)).setOnTouchListener(null);
		ScrollView sv;
		sv=((ScrollView)FC.findViewById(R.id.scroll_back));
		sv.setOnTouchListener(null);
	}
	private void repeat_click() {
		FC.repeatcard();
	}
	public void setup() {
		FC.setContentView(R.layout.back);
		((ScrollView)FC.findViewById(R.id.scroll_back)).setBackgroundColor(globals.bgcolor);
		((Button)FC.findViewById(R.id.missed_back)).setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) { repeat_click(); }
		});
		GD = new GestureDetector(FC, new SimpleOnGestureListener() {
			@Override
			public boolean onDown(MotionEvent e1) { return false; }
			@Override
			public boolean onSingleTapUp(MotionEvent e1) {
				FC.nextcard();
				return true;
			}
			@Override
			public boolean onFling(MotionEvent e1, MotionEvent e2, float velocityX, float velocityY) {
//				Log.e(DBG,"VelocityX: "+velocityX);
				if (velocityX<globals.nflingthreshold) FC.nextcard(); 
				else if (velocityX>globals.flingthreshold) FC.prevcard();
				else return false;
				return true;
			}
			});
		((ScrollView)FC.findViewById(R.id.scroll_back)).setOnTouchListener(new View.OnTouchListener() {
			@Override
			public boolean onTouch(View v, MotionEvent event) {
					return GD.onTouchEvent(event);
			}
		});
	}
	private String htmlesc(String in) {
		String out;
		out=in.replaceAll("&","&amp;");
		out=out.replaceAll("<","&lt;");
		out=out.replaceAll(">","&gt;");
		return in;
	}
	private void addtitle2(LinearLayout dest, String leadin, String link) {
		TextView tv;
		tv=new TextView(FC);
		tv.setTextSize(TypedValue.COMPLEX_UNIT_SP,25.0f);
		LinearLayout.LayoutParams lp;
		lp=new LinearLayout.LayoutParams(ViewGroup.LayoutParams.FILL_PARENT,
			ViewGroup.LayoutParams.WRAP_CONTENT);
		lp.setMargins(0,50,0,0);
		tv.setLayoutParams(lp);
		tv.setGravity(Gravity.CENTER_HORIZONTAL);
		if (link.length()==0) tv.setText(leadin);
		else tv.setText(link);
		tv.setTextColor(globals.fgcolor);
		dest.addView(tv);
	}
	private void addtitle(LinearLayout dest, notion title) {
		if ((title.string.length()==0)&&(null!=title.bitmap)) addtitle2(dest,"Facts about [Image]","");
		else addtitle2(dest,"Facts about",title.string);
	}
	private void addfact(LinearLayout dest, notion not) {
		if (not.string.length()!=0) {
			FC.addwikilink(not.string);
			TextView tv;
			tv=new TextView(FC);
			tv.setTextSize(TypedValue.COMPLEX_UNIT_SP,25.0f);
			tv.setLayoutParams(new LinearLayout.LayoutParams(ViewGroup.LayoutParams.FILL_PARENT,
				ViewGroup.LayoutParams.WRAP_CONTENT));
			tv.setGravity(Gravity.LEFT);
			tv.setText(not.string);
			tv.setTextColor(globals.fgcolor);
			dest.addView(tv);
		}
		if (not.bitmap!=null) {
			ImageView iv;
			iv=new ImageView(FC);
			iv.setImageBitmap(globals.makebitmap(not.bitmap));
			iv.setLayoutParams(new LinearLayout.LayoutParams(ViewGroup.LayoutParams.FILL_PARENT,(int)(50*dpratio)));
			dest.addView(iv);
		}
	}
	private void addnotion(LinearLayout dest, notion not, float rightsize) {
		if (!not.string.equals("")) {
			FC.addwikilink(not.string);
			if (not.bitmap==null) rightsize*=1.2;
			TextView tv;
			tv=new TextView(FC);
			tv.setTextSize(TypedValue.COMPLEX_UNIT_SP,rightsize);
			tv.setLayoutParams(new LinearLayout.LayoutParams(
				ViewGroup.LayoutParams.FILL_PARENT,
				ViewGroup.LayoutParams.WRAP_CONTENT));
			tv.setText(not.string);
			tv.setGravity(Gravity.CENTER_HORIZONTAL);
			tv.setTextColor(globals.fgcolor);
			final String wikilink=not.string;
/*
			tv.setOnLongClickListener(new View.OnLongClickListener() {
				@Override
				public boolean onLongClick(View v) { wikilookup(wikilink); return true; }
			});
			tv.setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) { FC.nextcard(); }
			});
*/
			dest.addView(tv);
		}
		if (not.bitmap!=null) {
			ImageView iv;
			int size=(int)(rightsize*2*dpratio);
			iv=new ImageView(FC);
			iv.setImageBitmap(globals.makebitmap(not.bitmap));
			if (not.string.equals("")) size=pixels;
			iv.setLayoutParams(new LinearLayout.LayoutParams(
				ViewGroup.LayoutParams.FILL_PARENT,size));
			dest.addView(iv);
		}
	}
	public void drawcard(card card, boolean denyfacts) {
		LinearLayout tainer;
		float rightsize;
		boolean showfacts;

		FC.addwikilink(card.leftn.string);
		FC.addwikilink(card.question);

		if (denyfacts) {
			globals.settextview(FC,R.id.topic_back,"");
			globals.setnotion3(FC,R.id.left_back,R.id.leftiv_back,"",null,null);
		} else {
			String left;
			if (null!=card.question) {
				globals.settextview(FC,R.id.topic_back,"");
				left=card.question;
			} else {
				globals.settextview(FC,R.id.topic_back,card.dim);
				left=card.leftn.string;
			}
			globals.setnotion3(FC,R.id.left_back,R.id.leftiv_back,left,card.leftn.bitmap,null);
		}

		tainer=(LinearLayout)FC.findViewById(R.id.right_back);
		tainer.removeAllViews();
		if ((!denyfacts)&&(globals.facts==0)&&(card.facts.length>1)) {
			showfacts=true;
			rightsize=35;
		} else {
			showfacts=false;
			rightsize=50;
		}
		for (int i=0,n=card.rightns.length;i<n;i++) addnotion(tainer,card.rightns[i],rightsize);

		tainer=(LinearLayout)FC.findViewById(R.id.facts_back);
		tainer.removeAllViews();
		if (showfacts) {
			addtitle(tainer,card.leftn);
			for (int i=0,n=card.facts.length;i<n;i++) addfact(tainer,card.facts[i]);
		}
		if (FC.isforward) globals.startanimation(FC,R.id.linear_back,R.anim.left);
		else globals.startanimation(FC,R.id.linear_back,R.anim.right);
	}
}
