package com.survey7.flashcards;

/*
Copyright 2012 Sanjay Rao, Seattle WA USA

This file is part of Flash Cards GPL.

Flash Cards GPL is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

Flash Cards GPL is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Flash Cards GPL.  If not, see <http://www.gnu.org/licenses/>.
*/

import java.util.Collections;
import java.util.Arrays;
import android.os.Handler;
import android.content.res.Configuration;
import android.app.Activity;
import android.os.Bundle;
import android.text.Html;
import android.view.GestureDetector;
import android.view.GestureDetector.SimpleOnGestureListener;
import android.view.MotionEvent;
import android.view.Window;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Button;
import android.view.Gravity;
import android.view.ViewGroup;
import android.util.Log;
import java.lang.StringBuilder;
import android.text.SpannableString;
import android.text.style.UnderlineSpan;
import android.graphics.Color;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.view.animation.Animation.AnimationListener;
import android.graphics.Bitmap;
import android.widget.ImageView;

public class front implements cardside {
	private static final String DBG="FlashCards";
	FlashCards FC;
	Handler onehandler=null;
	Runnable pulse;
	GestureDetector GD;
	private Globals globals;
	boolean onoff=false;
	int timerfuse=0;
	int defcountdown;

	private void putdefcountdown() {
		globals.countdown=defcountdown;
		globals.savepreferences();
	}

	public void setactivity(FlashCards act) {
		FC=act;
		globals=(Globals)((Globalcontainer)FC.getApplicationContext()).globals;
		defcountdown=globals.countdown;
	}
	public void unsetup() {
		onoff=false;
		((LinearLayout)FC.findViewById(R.id.frontlayout)).setOnTouchListener(null);
		onehandler.removeCallbacks(pulse);
	}
	private void nextcard() {
		onoff=false;
/*
		Animation anim=AnimationUtils.loadAnimation(FC,R.anim.left);
		((LinearLayout)FC.findViewById(R.id.frontlayout)).startAnimation(anim);
		anim.setAnimationListener(new AnimationListener() {
			public void onAnimationStart(Animation animation) {}
			public void onAnimationRepeat(Animation animation) {}
			public void onAnimationEnd(Animation animation) {
				((LinearLayout)FC.findViewById(R.id.frontlayout)).setVisibility(View.GONE);
				onehandler.postDelayed(fcshowbuttons,0);
			}
		});
*/
		FC.showbuttons();
	}
	private void pausetimer() {
		onoff=false;
		if (defcountdown<0) {
			((Button)FC.findViewById(R.id.enable)).setVisibility(View.VISIBLE);
			globals.settextview(FC,R.id.countdown,R.string.off);
		} else {
			((Button)FC.findViewById(R.id.faster)).setVisibility(View.VISIBLE);
			((Button)FC.findViewById(R.id.slower)).setVisibility(View.VISIBLE);
			((Button)FC.findViewById(R.id.disable)).setVisibility(View.VISIBLE);
			globals.settextview(FC,R.id.countdown,""+defcountdown);
		}
	}
	private void togglecounter(boolean flag) {
		if (flag) {
			((Button)FC.findViewById(R.id.faster)).setVisibility(View.VISIBLE);
			((Button)FC.findViewById(R.id.slower)).setVisibility(View.VISIBLE);
			((Button)FC.findViewById(R.id.disable)).setVisibility(View.VISIBLE);
			((Button)FC.findViewById(R.id.enable)).setVisibility(View.GONE);
			defcountdown=globals.defcountdown;
			putdefcountdown();
			globals.settextview(FC,R.id.countdown,""+defcountdown);
		} else {
			((Button)FC.findViewById(R.id.enable)).setVisibility(View.VISIBLE);
			((Button)FC.findViewById(R.id.faster)).setVisibility(View.GONE);
			((Button)FC.findViewById(R.id.slower)).setVisibility(View.GONE);
			((Button)FC.findViewById(R.id.disable)).setVisibility(View.GONE);
			defcountdown=-1;
			putdefcountdown();
			globals.settextview(FC,R.id.countdown,R.string.off);
		}
	}
	private void faster(int delta) {
		defcountdown-=delta;
		if (defcountdown<0) defcountdown=0;
		globals.settextview(FC,R.id.countdown,""+defcountdown);
		putdefcountdown();
	}
	public void setup() {
		FC.setContentView(R.layout.front);
		onoff=true;
		if (null==onehandler) {
			onehandler=new Handler();
			pulse=new Runnable() {
				public void run() { settimer();	}
			};
		}
		GD = new GestureDetector(FC, new SimpleOnGestureListener() {
			@Override
			public boolean onDown(MotionEvent e1) { return true; }
			@Override
			public boolean onSingleTapUp(MotionEvent e1) {
				nextcard();
				return true;
			}
			@Override
			public boolean onFling(MotionEvent e1, MotionEvent e2, float velocityX, float velocityY) {
				if (velocityX<globals.nflingthreshold) nextcard();
				else if (velocityX>globals.flingthreshold) FC.prevcard();
				else return false;
				return true;
			}
			});
		((LinearLayout)FC.findViewById(R.id.frontlayout)).setOnTouchListener(new View.OnTouchListener() {
			@Override
			public boolean onTouch(View v, MotionEvent event) {
					return GD.onTouchEvent(event);
			}
		});
		((TextView)FC.findViewById(R.id.countdown)).setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) { pausetimer(); }
			});
		((Button)FC.findViewById(R.id.faster)).setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) { faster(5); }
			});
		((Button)FC.findViewById(R.id.slower)).setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) { faster(-5); }
			});
		((Button)FC.findViewById(R.id.enable)).setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) { togglecounter(true); }
			});
		((Button)FC.findViewById(R.id.disable)).setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) { togglecounter(false); }
			});
	}
	private void settimer() {
		if (!onoff) return;
		if (timerfuse<0) return;
		if (0==timerfuse) {
			FC.showbuttons();
			return;
		}
		timerfuse--;
		globals.settextview(FC,R.id.countdown,""+timerfuse);
		onehandler.postDelayed(pulse,1000);
	}
	public void drawcard(card card, boolean flag) {
		String mainstr;
		String dim;
		FC.addwikilink(card.leftn.string);
		FC.addwikilink(card.question);
		if (null!=card.question) {
			dim="";
			mainstr=card.question;
		} else {
			dim=card.dim;
			mainstr=card.leftn.string;
		}
		ImageView IV=(ImageView)FC.findViewById(R.id.mainimage);
		if (card.leftn.hint!=null) {
			if (!dim.equals("")) dim+=", ";
			dim+=mainstr;
			globals.setnotion3(FC,R.id.mainview,R.id.mainimage,"",card.leftn.hint,null);
		} else {
			globals.setnotion3(FC,R.id.mainview,R.id.mainimage,mainstr,card.leftn.bitmap,null);
		}
		globals.settextview(FC,R.id.topic,dim);
		globals.startanimation(FC,R.id.frontlayout,R.anim.left);
		globals.setbackground(FC,R.id.frontlayout,true);
		timerfuse=defcountdown;
		settimer();
	}
}
